package dev.shadowsoffire.apotheosis.mixin;

import net.minecraft.network.chat.Style;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import org.spongepowered.asm.mixin.injection.Redirect;
import java.util.Iterator;
import java.util.Collection;
import java.util.Collections;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.core.registries.BuiltInRegistries;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import net.minecraft.nbt.ListTag;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.CommonComponents;
import dev.shadowsoffire.apotheosis.ench.asm.EnchHooks;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.List;
import org.spongepowered.asm.mixin.injection.ModifyVariable;
import java.util.stream.DoubleStream;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import javax.annotation.Nullable;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.RandomSource;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.network.chat.ComponentContents;
import net.minecraft.nbt.CompoundTag;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import net.minecraft.network.chat.contents.TranslatableContents;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import net.minecraft.network.chat.Component;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.world.item.ItemStack;
import org.spongepowered.asm.mixin.Mixin;

@Mixin(value = { ItemStack.class }, priority = 500)
public class ItemStackMixin
{
    @Inject(method = { "getHoverName" }, at = { @At("RETURN") }, cancellable = true)
    public void apoth_affixItemName(final CallbackInfoReturnable<Component> cir) {
        final ItemStack ths = (ItemStack)this;
        final CompoundTag afxData = ths.m_41737_("affix_data");
        if (afxData != null && afxData.m_128425_("name", 8)) {
            try {
                final Component component = AffixHelper.getName(ths);
                final ComponentContents 214077_ = component.m_214077_();
                if (214077_ instanceof final TranslatableContents tContents) {
                    final int idx = "misc.apotheosis.affix_name.four".equals(tContents.m_237508_()) ? 2 : 1;
                    tContents.m_237523_()[idx] = cir.getReturnValue();
                    cir.setReturnValue((Object)component);
                }
                else {
                    afxData.m_128473_("name");
                }
            }
            catch (final Exception exception) {
                afxData.m_128473_("name");
            }
        }
        final DynamicHolder<LootRarity> rarity = (DynamicHolder<LootRarity>)AffixHelper.getRarity(afxData);
        if (rarity.isBound()) {
            final Component recolored = (Component)((Component)cir.getReturnValue()).m_6881_().m_130938_(s -> s.m_131148_(((LootRarity)rarity.get()).getColor()));
            cir.setReturnValue((Object)recolored);
        }
    }
    
    @ModifyVariable(at = @At(value = "INVOKE", target = "net/minecraft/world/item/ItemStack.getDamageValue()I"), method = { "hurt" }, argsOnly = true, ordinal = 0)
    public int swapDura(final int amount, final int amountCopy, final RandomSource pRandom, @Nullable final ServerPlayer pUser) {
        int blocked = 0;
        final DoubleStream socketBonuses = SocketHelper.getGems((ItemStack)this).getDurabilityBonusPercentage(pUser);
        final DoubleStream afxBonuses = AffixHelper.streamAffixes((ItemStack)this).mapToDouble(inst -> inst.getDurabilityBonusPercentage(pUser));
        final DoubleStream bonuses = DoubleStream.concat(socketBonuses, afxBonuses);
        double chance = bonuses.reduce(0.0, (res, ele) -> res + (1.0 - res) * ele);
        int delta = 1;
        if (chance < 0.0) {
            delta = -1;
            chance = -chance;
        }
        if (chance > 0.0) {
            for (int i = 0; i < amount; ++i) {
                if (pRandom.m_188501_() <= chance) {
                    blocked += delta;
                }
            }
        }
        return amount - blocked;
    }
    
    private static void appendModifiedEnchTooltip(final List<Component> tooltip, final Enchantment ench, final int realLevel, final int nbtLevel) {
        final MutableComponent mc = ench.m_44700_(realLevel).m_6881_();
        mc.m_7360_().clear();
        final Component nbtLevelComp = (Component)Component.m_237115_("enchantment.level." + nbtLevel);
        final Component realLevelComp = (Component)Component.m_237115_("enchantment.level." + realLevel);
        if (realLevel != 1 || EnchHooks.getMaxLevel(ench) != 1) {
            mc.m_7220_(CommonComponents.f_263701_).m_7220_(realLevelComp);
        }
        final int diff = realLevel - nbtLevel;
        final char sign = (diff > 0) ? '+' : '-';
        final Component diffComp = (Component)Component.m_237110_("(%s " + sign + " %s)", new Object[] { nbtLevelComp, Component.m_237115_("enchantment.level." + Math.abs(diff)) }).m_130940_(ChatFormatting.DARK_GRAY);
        mc.m_7220_(CommonComponents.f_263701_).m_7220_(diffComp);
        if (realLevel == 0) {
            mc.m_130940_(ChatFormatting.DARK_GRAY);
        }
        tooltip.add((Component)mc);
    }
    
    @Redirect(method = { "getTooltipLines" }, at = @At(value = "INVOKE", target = "Lnet/minecraft/world/item/ItemStack;appendEnchantmentNames(Ljava/util/List;Lnet/minecraft/nbt/ListTag;)V"))
    public void apoth_enchTooltipRewrite(final List<Component> tooltip, final ListTag tagEnchants) {
        final ItemStack ths = (ItemStack)this;
        final Map<Enchantment, Integer> realLevels = new HashMap<Enchantment, Integer>(ths.getAllEnchantments());
        final List<Component> enchTooltips = new ArrayList<Component>();
        for (int i = tagEnchants.size() - 1; i >= 0; --i) {
            final CompoundTag compoundtag = tagEnchants.m_128728_(i);
            final Enchantment ench = (Enchantment)BuiltInRegistries.f_256876_.m_7745_(EnchantmentHelper.m_182446_(compoundtag));
            if (ench != null) {
                if (realLevels.containsKey(ench)) {
                    final int nbtLevel = EnchantmentHelper.m_182438_(compoundtag);
                    final int realLevel = realLevels.remove(ench);
                    if (nbtLevel == realLevel) {
                        enchTooltips.add(ench.m_44700_(EnchantmentHelper.m_182438_(compoundtag)));
                    }
                    else {
                        appendModifiedEnchTooltip(enchTooltips, ench, realLevel, nbtLevel);
                    }
                }
            }
        }
        Collections.reverse(enchTooltips);
        tooltip.addAll(enchTooltips);
        for (final Map.Entry<Enchantment, Integer> real : realLevels.entrySet()) {
            if (real.getValue() > 0) {
                appendModifiedEnchTooltip(tooltip, real.getKey(), real.getValue(), 0);
            }
        }
    }
}
